diff --git a/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19132To19133.java b/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19132To19133.java
index eeb2b6182..0674d27fe 100644
--- a/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19132To19133.java
+++ b/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19132To19133.java
@@ -1,11 +1,13 @@
 package net.minecraft.core.world.save.conversion;
 
+import com.mojang.logging.LogUtils;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.NbtIo;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.save.mcregion.RegionFile;
 import net.minecraft.core.world.save.mcregion.RegionFileCache;
+import org.slf4j.Logger;
 
 import java.io.DataInputStream;
 import java.io.DataOutputStream;
@@ -17,6 +19,7 @@ import java.util.Collections;
 public class SaveConverter19132To19133
     extends SaveConverterMCRegionBase
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
     @Override
     public int fromVersion()
     {
@@ -125,7 +128,7 @@ public class SaveConverter19132To19133
                     }
                     catch(IOException e)
                     {
-                        e.printStackTrace();
+                        LOGGER.error("Failed to convert chunk X:{}, Z:{}, in region {}!", x, z, region.toPath(), e);
                     }
 
                 }
diff --git a/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19133To19134.java b/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19133To19134.java
index 1790bc671..4f278edf6 100644
--- a/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19133To19134.java
+++ b/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19133To19134.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.world.save.conversion;
 
+import com.mojang.logging.LogUtils;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.data.legacy.LegacyWorldTypes;
 import net.minecraft.core.world.Dimension;
@@ -7,6 +8,7 @@ import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.save.DimensionData;
 import net.minecraft.core.world.save.ISaveFormat;
 import net.minecraft.core.world.save.SaveFormats;
+import org.slf4j.Logger;
 
 
 import java.io.*;
@@ -19,6 +21,7 @@ import java.util.Map;
 public class SaveConverter19133To19134
     extends SaveConverterMCRegionBase
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
     @Override
     public int fromVersion()
     {
@@ -82,7 +85,7 @@ public class SaveConverter19133To19134
         List<File> dimensionDirs = new ArrayList<>();
         Map<File, ArrayList<File>> dimensionRegionFiles = new HashMap<>();
 
-        System.out.println("Scanning folders...");
+        LOGGER.info("Scanning folders...");
 
         // Add directory files for each present dimension
         for (Dimension dim : Dimension.getDimensionList().values())
@@ -102,7 +105,7 @@ public class SaveConverter19133To19134
         {
             totalConversions += dimensionRegionFiles.get(dimensionDir).size();
         }
-        System.out.println("Total conversion count is " + totalConversions);
+        LOGGER.info("Total conversion count is {}", totalConversions);
 
         // Convert regions for each dimension
         progress.progressStagePercentage(0);
@@ -144,7 +147,7 @@ public class SaveConverter19133To19134
                     }
                     catch (IOException e)
                     {
-                        e.printStackTrace();
+                        LOGGER.error("Failed to copy file {} to {}!", file.toPath(), new File(destDir, file.getName()).toPath(), e);
                     }
                 }
             }
diff --git a/src/main/java/net/minecraft/core/world/save/conversion/SaveConverterLegacyTo19132.java b/src/main/java/net/minecraft/core/world/save/conversion/SaveConverterLegacyTo19132.java
index bb3f826d1..b3df2469a 100644
--- a/src/main/java/net/minecraft/core/world/save/conversion/SaveConverterLegacyTo19132.java
+++ b/src/main/java/net/minecraft/core/world/save/conversion/SaveConverterLegacyTo19132.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.world.save.conversion;
 
+import com.mojang.logging.LogUtils;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.data.legacy.LegacyWorldTypes;
 import net.minecraft.core.world.ProgressListener;
@@ -11,16 +12,20 @@ import net.minecraft.core.world.save.legacy.ChunkFilePattern;
 import net.minecraft.core.world.save.legacy.ChunkFolderPattern;
 import net.minecraft.core.world.save.mcregion.RegionFile;
 import net.minecraft.core.world.save.mcregion.RegionFileCache;
+import org.slf4j.Logger;
 
 import java.io.*;
+import java.nio.file.Files;
 import java.util.ArrayList;
 import java.util.Collections;
 import java.util.Iterator;
+import java.util.List;
 import java.util.zip.GZIPInputStream;
 
 public class SaveConverterLegacyTo19132
     implements ISaveConverter
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
     @Override
     public int fromVersion()
     {
@@ -107,16 +112,16 @@ public class SaveConverterLegacyTo19132
         for(Iterator<ChunkFile> iterator = chunkFileList.iterator(); iterator.hasNext(); progress.progressStagePercentage(numConversions))
         {
             ChunkFile chunkfile = iterator.next();
-            int k = chunkfile.getX();
-            int l = chunkfile.getZ();
-            RegionFile regionfile = RegionFileCache.loadRegionFileFromCoords(file, k, l);
-            if(!regionfile.chunkExists(k & 0x1f, l & 0x1f))
+            int x = chunkfile.getX();
+            int z = chunkfile.getZ();
+            RegionFile regionfile = RegionFileCache.loadRegionFileFromCoords(file, x, z);
+            if(!regionfile.chunkExists(x & 0x1f, z & 0x1f))
             {
                 try
                 {
-                    DataInputStream datainputstream = new DataInputStream(new GZIPInputStream(new FileInputStream(chunkfile.getChunkFile())));
-                    DataOutputStream dataoutputstream = regionfile.getChunkDataOutputStream(k & 0x1f, l & 0x1f);
-                    for(int j1 = 0; (j1 = datainputstream.read(fileBuffer)) != -1;)
+                    DataInputStream datainputstream = new DataInputStream(new GZIPInputStream(Files.newInputStream(chunkfile.getChunkFile().toPath())));
+                    DataOutputStream dataoutputstream = regionfile.getChunkDataOutputStream(x & 0x1f, z & 0x1f);
+                    for(int j1; (j1 = datainputstream.read(fileBuffer)) != -1;)
                     {
                         dataoutputstream.write(fileBuffer, 0, j1);
                     }
@@ -126,7 +131,7 @@ public class SaveConverterLegacyTo19132
                 }
                 catch(IOException ioexception)
                 {
-                    ioexception.printStackTrace();
+                    LOGGER.error("Failed to convert chunk X:{}, Z:{}, in region {}!", x, z, regionfile);
                 }
             }
             conversionsPerformed++;
@@ -136,17 +141,17 @@ public class SaveConverterLegacyTo19132
         RegionFileCache.flushCache();
     }
 
-    private void deleteOldWorldData(ArrayList arraylist, int i, int j, ProgressListener iprogressupdate)
+    private void deleteOldWorldData(List<File> files, int conversionsPerformed, int totalConversions, ProgressListener progressListener)
     {
         int k;
-        for(Iterator iterator = arraylist.iterator(); iterator.hasNext(); iprogressupdate.progressStagePercentage(k))
+        for(Iterator<File> iterator = files.iterator(); iterator.hasNext(); progressListener.progressStagePercentage(k))
         {
-            File file = (File)iterator.next();
-            File afile[] = file.listFiles();
+            File file = iterator.next();
+            File[] afile = file.listFiles();
             deleteFilesRecursively(afile);
             file.delete();
-            i++;
-            k = (int)Math.round((100D * (double)i) / (double)j);
+            conversionsPerformed++;
+            k = (int)Math.round((100D * (double)conversionsPerformed) / (double)totalConversions);
         }
 
     }
diff --git a/src/main/java/net/minecraft/core/world/save/mcregion/RegionFile.java b/src/main/java/net/minecraft/core/world/save/mcregion/RegionFile.java
index 7b86cd0b7..5a6285166 100644
--- a/src/main/java/net/minecraft/core/world/save/mcregion/RegionFile.java
+++ b/src/main/java/net/minecraft/core/world/save/mcregion/RegionFile.java
@@ -1,5 +1,9 @@
 package net.minecraft.core.world.save.mcregion;
 
+import com.mojang.logging.LogUtils;
+import net.minecraft.core.Global;
+import org.slf4j.Logger;
+
 import java.io.*;
 import java.util.ArrayList;
 import java.util.zip.*;
@@ -9,6 +13,7 @@ import java.util.zip.*;
  */
 public class RegionFile
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
     private static final byte[] emptySector = new byte[4096];
     private final File regionFile;
     private RandomAccessFile dataFile;
@@ -103,7 +108,7 @@ public class RegionFile
         }
         catch(IOException e)
         {
-            e.printStackTrace();
+            LOGGER.error("Failed to fully load region data for region '{}'!", regionFile.getPath());
         }
     }
 
@@ -124,7 +129,7 @@ public class RegionFile
      */
     private void print(String message)
     {
-//        System.out.println(message);
+        LOGGER.debug(message);
     }
 
     /**
@@ -380,7 +385,7 @@ public class RegionFile
         }
         catch(IOException ioexception)
         {
-            ioexception.printStackTrace();
+            LOGGER.error("Failed to fully write data for region file '{}'!", regionFile.getPath(), ioexception);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/world/save/mcregion/RegionFileCache.java b/src/main/java/net/minecraft/core/world/save/mcregion/RegionFileCache.java
index f13fa17ee..8c4d9c351 100644
--- a/src/main/java/net/minecraft/core/world/save/mcregion/RegionFileCache.java
+++ b/src/main/java/net/minecraft/core/world/save/mcregion/RegionFileCache.java
@@ -1,5 +1,8 @@
 package net.minecraft.core.world.save.mcregion;
 
+import com.mojang.logging.LogUtils;
+import org.slf4j.Logger;
+
 import java.io.*;
 import java.lang.ref.Reference;
 import java.lang.ref.SoftReference;
@@ -7,7 +10,7 @@ import java.util.*;
 
 public class RegionFileCache
 {
-
+    private static final Logger LOGGER = LogUtils.getLogger();
     private RegionFileCache()
     {
     }
@@ -52,7 +55,7 @@ public class RegionFileCache
             }
             catch (IOException ex)
             {
-                ex.printStackTrace();
+                LOGGER.error("Exception while flushing references", ex);
             }
         }
         cache.clear();
diff --git a/src/main/java/net/minecraft/core/world/saveddata/SavedDataStorage.java b/src/main/java/net/minecraft/core/world/saveddata/SavedDataStorage.java
index abd51f6a7..a33901707 100644
--- a/src/main/java/net/minecraft/core/world/saveddata/SavedDataStorage.java
+++ b/src/main/java/net/minecraft/core/world/saveddata/SavedDataStorage.java
@@ -1,10 +1,13 @@
 package net.minecraft.core.world.saveddata;
 
+import com.mojang.logging.LogUtils;
 import com.mojang.nbt.Tag;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ShortTag;
 import com.mojang.nbt.NbtIo;
+import net.minecraft.core.Global;
 import net.minecraft.core.world.save.LevelStorage;
+import org.slf4j.Logger;
 
 import java.io.*;
 import java.nio.file.Files;
@@ -16,6 +19,7 @@ import java.util.*;
 
 public class SavedDataStorage
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
     private final LevelStorage storage;
     private final Map<Serializable, SavedData> cache;
     private final List<SavedData> loadedData;
@@ -52,7 +56,7 @@ public class SavedDataStorage
                     {
                         throw new RuntimeException("Failed to instantiate " + savedDataClass.toString(), exception1);
                     }
-                    FileInputStream fis = new FileInputStream(file);
+                    InputStream fis = Files.newInputStream(file.toPath());
                     CompoundTag tag = NbtIo.readCompressed(fis);
                     fis.close();
                     savedData.load(tag.getCompound("data"));
@@ -60,7 +64,7 @@ public class SavedDataStorage
             }
             catch(Exception e)
             {
-                e.printStackTrace();
+                LOGGER.error("Exception loading saved data for id '{}'!", id, e);
             }
         }
         if(savedData != null)
@@ -113,14 +117,14 @@ public class SavedDataStorage
                 savedData.save(dataTag);
                 CompoundTag tag = new CompoundTag();
                 tag.putCompound("data", dataTag);
-                FileOutputStream fos = new FileOutputStream(file);
+                OutputStream fos = Files.newOutputStream(file.toPath());
                 NbtIo.writeCompressed(tag, fos);
                 fos.close();
             }
         }
         catch(Exception exception)
         {
-            exception.printStackTrace();
+            LOGGER.error("Failed to save data to '{}'!", storage.getDataFile(savedData.id).getPath(), exception);
         }
     }
 
@@ -151,7 +155,7 @@ public class SavedDataStorage
         }
         catch(Exception e)
         {
-            e.printStackTrace();
+            LOGGER.error("Failed to load all savedata id counts!", e);
         }
     }
 
@@ -190,7 +194,7 @@ public class SavedDataStorage
         }
         catch(Exception e)
         {
-            e.printStackTrace();
+            LOGGER.error("Failed to create data file for '{}'!", storage.getDataFile("idcounts").getPath(), e);
         }
         return metadata;
     }
diff --git a/src/main/java/net/minecraft/core/world/weather/WeatherManager.java b/src/main/java/net/minecraft/core/world/weather/WeatherManager.java
index 47c3d9f4b..417b846d5 100644
--- a/src/main/java/net/minecraft/core/world/weather/WeatherManager.java
+++ b/src/main/java/net/minecraft/core/world/weather/WeatherManager.java
@@ -10,6 +10,7 @@ import java.util.Random;
 public class WeatherManager {
     private final World world;
 
+    private Weather lastWeather = null;
     private Weather currentWeather = null;
     private Weather nextWeather = null;
     private long weatherDuration = Global.DAY_LENGTH_TICKS;
@@ -34,6 +35,7 @@ public class WeatherManager {
             this.weatherIntensity = 1.0f;
         }
     }
+    public Weather getLastWeather() { return lastWeather; }
 
     public Weather getCurrentWeather() {
         return currentWeather;
@@ -56,6 +58,7 @@ public class WeatherManager {
     }
 
     public void overrideWeather(Weather currentWeather, Weather nextWeather, long weatherDuration, float weatherIntensity, float weatherPower) {
+        this.lastWeather = this.currentWeather;
         this.currentWeather = currentWeather;
         this.nextWeather = nextWeather;
         this.weatherDuration = weatherDuration;
@@ -64,6 +67,7 @@ public class WeatherManager {
     }
 
     public void overrideWeather(Weather weather, long duration, float power) {
+        lastWeather = currentWeather;
         currentWeather = weather;
         nextWeather = null;
         weatherDuration = duration;
@@ -91,7 +95,10 @@ public class WeatherManager {
         if (world.getSeasonManager().getCurrentSeason() == null)
             return false;
 
-        if (currentWeather == null) currentWeather = world.worldType.getDefaultWeather();
+        if (currentWeather == null) {
+            lastWeather = null;
+            currentWeather = world.worldType.getDefaultWeather();
+        }
 
         if (nextWeather == null && weatherIntensity <= 1.0f)
         {
@@ -102,8 +109,15 @@ public class WeatherManager {
         else if (nextWeather != null && weatherIntensity >= 0.0f)
         {
             weatherIntensity -= 0.002f;
+            if (!world.isClientSide) {
+                if (world.dayCanHaveRainbow && world.rainbowTicks <= 0 && weatherIntensity < 0.5f && currentWeather.precipitationType == 0 && !nextWeather.isPrecipitation){ // On rain end
+                    int rainbowTicks = world.rand.nextInt(20 * 90) + 20 * 30;
+                    world.addRainbow(rainbowTicks);
+                }
+            }
             if (weatherIntensity <= 0.0f) {
                 weatherIntensity = 0.0f;
+                lastWeather = currentWeather;
                 currentWeather = nextWeather;
                 weatherPower = getRandomWeatherPower();
                 nextWeather = null;
